<?php

namespace Ems\Repository;

use Doctrine\ORM\EntityManager;

class RescisaoRepository {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    
    public function getTpAvisoPrevio($nrorg) {
        $sql = <<<SQL
    SELECT
        * 
    FROM
       GPE_TIPOAVISOPRE 
    WHERE
       NRORG = :P_NRORG 
       OR NRORG = 0
SQL;

        
        $query = $this->entityManager->getConnection()->prepare($sql);

        $query->execute(
            array(
                'P_NRORG'           => $nrorg
            )
        );

        $resultQuery = $query->fetchAll();


        if (isset($resultQuery)) {
            return $resultQuery;
        } else {
            return null;
        }
    }
    
    public function getTpDemissao($nrorg) {
        $sql = <<<SQL
    SELECT
        * 
    FROM
       FPA_TPDEMISSAO 
    WHERE
       (
          NRORG = :P_NRORG 
          OR NRORG = 0
       )
     AND NMABREV IS NOT NULL
SQL;

        
        $query = $this->entityManager->getConnection()->prepare($sql);

        $query->execute(
            array(
                'P_NRORG'           => $nrorg
            )
        );

        $resultQuery = $query->fetchAll();


        if (isset($resultQuery)) {
            return $resultQuery;
        } else {
            return null;
        }
    }
    
    
    public function getMotivoResc($nrorg) {
        $sql = <<<SQL
    SELECT
        * 
    FROM
       GPE_MOTIVORESC 
    WHERE
       (
          NRORG = :P_NRORG 
          OR NRORG = 0
       )
SQL;

        
        $query = $this->entityManager->getConnection()->prepare($sql);

        $query->execute(
            array(
                'P_NRORG'           => $nrorg
            )
        );

        $resultQuery = $query->fetchAll();


        if (isset($resultQuery)) {
            return $resultQuery;
        } else {
            return null;
        }
    }

}