/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: CARG_DESCSOL_COT                                                     */
/*                                                                            */
/* Descrio:                                                                 */
/* Joga para a descrio do Item de Coleta a(s) descrio(es) do(s) item(s)  */
/* de solicitao(es) de compras.                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 10/02/2001 - Adriano de Arajo                                             */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/* @C:\SISTEMAS\DBA\SQL\ORACLE\8610_SUPSTP_CARG_DESCSOL_COT.SQL               */
/* @H:\SISTEMAS\DBA\SQL\ORACLE\8610_SUPSTP_CARG_DESCSOL_COT.SQL               */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'CARG_DESCSOL_COT'  and
            type = 'P'                  and
            u.uid = o.uid               and
            u.name = USER)
  DROP PROCEDURE CARG_DESCSOL_COT
GO

CREATE PROCEDURE CARG_DESCSOL_COT
         @P_CDFILIAL    VARCHAR(4),
         @P_NRCOLEPRECO VARCHAR(10),
         @P_DTINI       DATETIME,
         @P_DTFIN       DATETIME
AS
  DECLARE @V_DSOBSITMCOL VARCHAR(1000);

  DECLARE @V_SOL_TXOBSITMSOL VARCHAR(2000);

  DECLARE @V_COTA_CDREGIAO  VARCHAR(3);
  DECLARE @V_COTA_CDPRODUTO VARCHAR(10);
BEGIN
  DECLARE C_COTA CURSOR FOR
     SELECT
       DISTINCT
        CDREGIAO,
        CDPRODUTO
     FROM
       ITEMCOLE
     WHERE
        CDFILIAL    = @P_CDFILIAL    AND
        NRCOLEPRECO = @P_NRCOLEPRECO AND
        QTACMPITMCOL > 0

  OPEN C_COTA;
  FETCH NEXT FROM C_COTA INTO @V_COTA_CDREGIAO, @V_COTA_CDPRODUTO;

  WHILE (@@FETCH_STATUS = 0)
  BEGIN
     SET @V_DSOBSITMCOL = NULL;

     DECLARE C_SOL CURSOR FOR
        SELECT
          ITEMSOLI.TXOBSITMSOL
        FROM
          ITEMSOLI,
          FILIAL
        WHERE
          ITEMSOLI.IDITMCONS = 'N'              AND
          ITEMSOLI.TXOBSITMSOL IS NOT NULL      AND
          FILIAL.CDREGIAO    = @V_COTA_CDREGIAO  AND
          ITEMSOLI.CDFILSOLI = FILIAL.CDFILIAL  AND
          ITEMSOLI.CDPRODUTO = @V_COTA_CDPRODUTO AND
          ITEMSOLI.DTPROGENTR BETWEEN @P_DTINI AND @P_DTFIN AND
          ISNULL(ITEMSOLI.IDSOLIAPROV,'S') = 'S'

     OPEN C_SOL;
     FETCH NEXT FROM C_SOL INTO @V_SOL_TXOBSITMSOL;
     WHILE (@@FETCH_STATUS = 0)
     BEGIN
       IF @V_DSOBSITMCOL IS NULL BEGIN
         SET @V_DSOBSITMCOL = @V_SOL_TXOBSITMSOL;
       END
       ELSE BEGIN
         SET @V_DSOBSITMCOL = @V_DSOBSITMCOL + CHAR(13) + @V_SOL_TXOBSITMSOL;
       END;

       FETCH NEXT FROM C_SOL INTO @V_SOL_TXOBSITMSOL;
     END;
     CLOSE C_SOL;
     DEALLOCATE C_SOL;

     UPDATE ITEMCOLE
     SET DSOBSITMCOL = SUBSTRING(@V_DSOBSITMCOL, 1, 1000)
     WHERE
       CDFILIAL    = @P_CDFILIAL      AND
       NRCOLEPRECO = @P_NRCOLEPRECO   AND
       CDREGIAO    = @V_COTA_CDREGIAO  AND
       CDPRODUTO   = @V_COTA_CDPRODUTO AND
       QTACMPITMCOL > 0;

     FETCH NEXT FROM C_COTA INTO @V_COTA_CDREGIAO, @V_COTA_CDPRODUTO;
  END;
  CLOSE C_COTA;
  DEALLOCATE C_COTA;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'CARG_DESCSOL_COT','5.40.000';
GO
